
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2.Objects.NotificationPermissionRequest
    ( 

-- * Exported types
    NotificationPermissionRequest(..)       ,
    NotificationPermissionRequestK          ,
    toNotificationPermissionRequest         ,
    noNotificationPermissionRequest         ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2.Types
import GI.WebKit2.Callbacks
import qualified GI.GObject as GObject

newtype NotificationPermissionRequest = NotificationPermissionRequest (ForeignPtr NotificationPermissionRequest)
foreign import ccall "webkit_notification_permission_request_get_type"
    c_webkit_notification_permission_request_get_type :: IO GType

type instance ParentTypes NotificationPermissionRequest = NotificationPermissionRequestParentTypes
type NotificationPermissionRequestParentTypes = '[GObject.Object, PermissionRequest]

instance GObject NotificationPermissionRequest where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_notification_permission_request_get_type
    

class GObject o => NotificationPermissionRequestK o
instance (GObject o, IsDescendantOf NotificationPermissionRequest o) => NotificationPermissionRequestK o

toNotificationPermissionRequest :: NotificationPermissionRequestK o => o -> IO NotificationPermissionRequest
toNotificationPermissionRequest = unsafeCastTo NotificationPermissionRequest

noNotificationPermissionRequest :: Maybe NotificationPermissionRequest
noNotificationPermissionRequest = Nothing

type instance AttributeList NotificationPermissionRequest = NotificationPermissionRequestAttributeList
type NotificationPermissionRequestAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList NotificationPermissionRequest = NotificationPermissionRequestSignalList
type NotificationPermissionRequestSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


